diff --git a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index 3614e14aa..01fa9f477 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -1,26 +1,27 @@
 package net.minecraft.client.render;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.List;
 import java.util.Random;
 
-import org.lwjgl.opengl.GL11;
+import net.minecraft.client.option.GameSettings;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.KeyBinding;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.MinecraftError;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
+import org.lwjgl.opengl.GL41;
 
 public class LoadingScreenRenderer
-    implements ProgressListener
-{
+    implements ProgressListener {
     private String stage = "";
-    private Minecraft minecraft;
+    private final Minecraft minecraft;
     private String title = "";
     private long startTime = System.currentTimeMillis();
     private boolean canStop = false;
@@ -28,30 +29,26 @@ public class LoadingScreenRenderer
     private int startStackDepth = 0;
     private String tip = "";
 
-    public LoadingScreenRenderer(Minecraft minecraft)
-    {
+    public LoadingScreenRenderer(Minecraft minecraft) {
         this.minecraft = minecraft;
     }
 
-    public void progressStartNoAbort(String title)
-    {
-        startStackDepth++;
-        canStop = false;
+    public void progressStartNoAbort(String title) {
+        this.startStackDepth++;
+        this.canStop = false;
         initialize(title);
     }
 
     @Override
-    public void progressStart(String title)
-    {
-        startStackDepth++;
-        canStop = true;
+    public void progressStart(String title) {
+        this.startStackDepth++;
+        this.canStop = true;
         initialize(title);
     }
 
     @Override
-    public void progressStop()
-    {
-        startStackDepth--;
+    public void progressStop() {
+        this.startStackDepth--;
     }
 
     private String parseTip(String tip) {
@@ -60,7 +57,7 @@ public class LoadingScreenRenderer
             if (s.startsWith("%")) {
                 KeyBinding binding = null;
                 String sub = s.substring(1);
-                for (KeyBinding b : minecraft.gameSettings.keys) {
+                for (KeyBinding b : GameSettings.keys) {
                     if (b.getId().equals(sub)) {
                         binding = b;
                         break;
@@ -75,143 +72,116 @@ public class LoadingScreenRenderer
         return tip;
     }
 
-    private void initialize(String title)
-    {
-        if(!minecraft.running)
-        {
-            if(!canStop)
-            {
+    private void initialize(String title) {
+        if (!this.minecraft.running) {
+            if (!this.canStop) {
                 throw new MinecraftError();
             }
-        }
-        else
-        {
+        } else {
             this.title = title;
-            if (startStackDepth <= 1)
-            {
+            if (this.startStackDepth <= 1) {
                 List<String> tips = I18n.getInstance().getCurrentLanguage().getTips();
                 String tipPre = TextFormatting.YELLOW + I18n.getInstance().translateKey("progress.tip");
                 String tipText = parseTip(tips.get(new Random().nextInt(tips.size())));
                 String tipMain = TextFormatting.WHITE + tipText;
-                tip = tipPre.replace("%s", tipMain);
+                this.tip = tipPre.replace("%s", tipMain);
             }
-            GL11.glClear(GL_DEPTH_BUFFER_BIT);
-            GL11.glMatrixMode(GL_PROJECTION);
-            GL11.glLoadIdentity();
-            GL11.glOrtho(0.0D, minecraft.resolution.getExactScaledWidthScreenCoords(), minecraft.resolution.getExactScaledHeightScreenCoords(), 0.0D, 100D, 300D);
-            GL11.glMatrixMode(GL_MODELVIEW);
-            GL11.glLoadIdentity();
-            GL11.glTranslatef(0.0F, 0.0F, -200F);
+            GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
+            GLRenderer.projectionM4f().identity().ortho(0.0f, (float) this.minecraft.resolution.getExactScaledWidthScreenCoords(), (float) this.minecraft.resolution.getExactScaledHeightScreenCoords(), 0.0f, 100f, 300f);
+            GLRenderer.viewM4f().identity().translate(0.0F, 0.0F, -200F);
         }
     }
 
-    public void updateLoadingBackground(Dimension dimension)
-    {
-        if (dimension == Dimension.NETHER)
-        {
-            backgroundPath = "/assets/minecraft/textures/gui/background-loading-nether.png";
-        }
-        else if (dimension == Dimension.DRIFT)
-        {
-            backgroundPath = "/assets/minecraft/textures/gui/background-loading-drift.png";
-        }
-        else
-        {
-            backgroundPath = "/assets/minecraft/textures/gui/background.png";
+    public void updateLoadingBackground(Dimension dimension) {
+        if (dimension == Dimension.NETHER) {
+            this.backgroundPath = "/assets/minecraft/textures/gui/background-loading-nether.png";
+        } else if (dimension == Dimension.DRIFT) {
+            this.backgroundPath = "/assets/minecraft/textures/gui/background-loading-drift.png";
+        } else {
+            this.backgroundPath = "/assets/minecraft/textures/gui/background.png";
         }
     }
 
     @Override
-    public void progressStage(String stage)
-    {
-        if(!minecraft.running)
-        {
-            if(!canStop)
-            {
+    public void progressStage(String stage) {
+        if (!this.minecraft.running) {
+            if (!this.canStop) {
                 throw new MinecraftError();
             }
-        }
-        else
-        {
-            startTime = 0L;
+        } else {
+            this.startTime = 0L;
             this.stage = stage;
             progressStagePercentage(-1);
-            startTime = 0L;
+            this.startTime = 0L;
         }
     }
 
     @Override
-    public void progressStagePercentage(int progress)
-    {
-        if(!minecraft.running)
-        {
-            if(!canStop)
-            {
+    public void progressStagePercentage(int progress) {
+        if (!this.minecraft.running) {
+            if (!this.canStop) {
                 throw new MinecraftError();
             }
         }
         long time = System.currentTimeMillis();
-        if(time - startTime < 20L)
-        {
+        if (time - this.startTime < 20L) {
             return;
         }
-        startTime = time;
+        this.startTime = time;
 
-        minecraft.renderer.beginRenderGame(1.0f);
-    	glEnable(GL_ALPHA_TEST);
+        this.minecraft.renderer.beginRenderGame(1.0f);
+//    	glEnable(GL_ALPHA_TEST);
 
         // Set up background
-        int width = minecraft.resolution.getScaledWidthScreenCoords();
-        int height = minecraft.resolution.getScaledHeightScreenCoords();
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glMatrixMode(GL_PROJECTION);
-        GL11.glLoadIdentity();
-        GL11.glOrtho(0.0D, minecraft.resolution.getExactScaledWidthScreenCoords(), minecraft.resolution.getExactScaledHeightScreenCoords(), 0.0D, 100D, 300D);
-        GL11.glMatrixMode(GL_MODELVIEW);
-        GL11.glLoadIdentity();
-        GL11.glTranslatef(0.0F, 0.0F, -200F);
-        Tessellator t = Tessellator.instance;
-        minecraft.textureManager.loadTexture(backgroundPath).bind();
+        int width = this.minecraft.resolution.getScaledWidthScreenCoords();
+        int height = this.minecraft.resolution.getScaledHeightScreenCoords();
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.projectionM4f().identity().ortho(0.0f, (float) this.minecraft.resolution.getExactScaledWidthScreenCoords(), (float) this.minecraft.resolution.getExactScaledHeightScreenCoords(), 0.0f, 100f, 300f);
+        GLRenderer.viewM4f().identity().translate(0.0F, 0.0F, -200F);
+        GLRenderer.modelM4f().identity();
+
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        this.minecraft.textureManager.loadTexture(this.backgroundPath).bind();
         float f = 32F;
 
         // Draw background
         t.startDrawingQuads();
-        t.setColorOpaque_I(0x404040);
-        t.addVertexWithUV(0.0D, height, 0.0D, 0.0D, (float)height / f);
-        t.addVertexWithUV(width, height, 0.0D, (float)width / f, (float)height / f);
-        t.addVertexWithUV(width, 0.0D, 0.0D, (float)width / f, 0.0D);
+        t.setColorOpaque1i(0x404040);
+        t.addVertexWithUV(0.0D, height, 0.0D, 0.0D, (float) height / f);
+        t.addVertexWithUV(width, height, 0.0D, (float) width / f, (float) height / f);
+        t.addVertexWithUV(width, 0.0D, 0.0D, (float) width / f, 0.0D);
         t.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
         t.draw();
 
         // Draw progress bar
-        if(progress >= 0)
-        {
+        if (progress >= 0) {
             byte barWidth = 100;
             byte barHeight = 2;
             int x = width / 2 - barWidth / 2;
             int y = height / 2 + 16;
-            GL11.glDisable(GL_TEXTURE_2D);
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR);
             t.startDrawingQuads();
-            t.setColorOpaque_I(0x808080);
+            t.setColorOpaque1i(0x808080);
             t.addVertex(x, y, 0.0D);
             t.addVertex(x, y + barHeight, 0.0D);
             t.addVertex(x + barWidth, y + barHeight, 0.0D);
             t.addVertex(x + barWidth, y, 0.0D);
-            t.setColorOpaque_I(0x80FF80);
+            t.setColorOpaque1i(0x80FF80);
             t.addVertex(x, y, 0.0D);
             t.addVertex(x, y + barHeight, 0.0D);
             t.addVertex(x + progress, y + barHeight, 0.0D);
             t.addVertex(x + progress, y, 0.0D);
             t.draw();
-            GL11.glEnable(GL_TEXTURE_2D);
+            GLRenderer.popFrame();
         }
 
         // Draw title and stage
-        this.minecraft.font.renderCentered(t, this.title, width / 2, height / 2 - 4 - 16).setShadow().call();
-        this.minecraft.font.renderCentered(t, this.stage, width / 2, (height / 2 - 4) + 8).setShadow().call();
+        this.minecraft.font.renderCentered(this.title, width / 2, height / 2 - 4 - 16).setShadow().call();
+        this.minecraft.font.renderCentered(this.stage, width / 2, (height / 2 - 4) + 8).setShadow().call();
 
         // Draw tip
-        this.minecraft.font.renderCentered(t, this.tip, width / 2, (height / 2 - 4) + 32).setShadow().call();
+        this.minecraft.font.renderCentered(this.tip, width / 2, (height / 2 - 4) + 32).setShadow().call();
 
         this.minecraft.renderer.endRenderGame(1.0f);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index 13a77552e..5fe1a6c41 100644
--- a/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -4,18 +4,20 @@ import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.TextureBuffered;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import net.minecraft.core.world.saveddata.maps.MapWaypoint;
+import org.joml.Math;
 import org.lwjgl.opengl.GL11;
 
-public class MapItemRenderer
-{
+public class MapItemRenderer {
     public static final int IMAGE_WIDTH = 128;
     public static final int IMAGE_HEIGHT = 128;
     public static final int IMAGE_AREA = 128 * 128;
@@ -23,33 +25,28 @@ public class MapItemRenderer
     private final int[] mapImageData;
     private TextureBuffered mapTexture;
 
-    public MapItemRenderer()
-    {
-        mapImageData = new int[IMAGE_AREA];
+    public MapItemRenderer() {
+        this.mapImageData = new int[IMAGE_AREA];
     }
 
     public void preRender() {
-        if (mapTexture == null) {
-            mapTexture = Minecraft.getMinecraft().textureManager.loadBufferedTexture(new BufferedImage(128, 128, 2));
-            for(int i = 0; i < IMAGE_AREA; i++)
-            {
-                mapImageData[i] = 0;
+        if (this.mapTexture == null) {
+            this.mapTexture = Minecraft.getMinecraft().textureManager.loadBufferedTexture(new BufferedImage(128, 128, 2));
+            for (int i = 0; i < IMAGE_AREA; i++) {
+                this.mapImageData[i] = 0;
             }
         }
     }
 
-    public void renderMap(Tessellator tessellator, ItemMapSavedData data, float brightness)
-    {
+    public void renderMap(TessellatorGeneral tessellator, ItemMapSavedData data) {
         preRender();
         TextureManager textureManager = Minecraft.getMinecraft().textureManager;
-        for(int i = 0; i < IMAGE_AREA; i++)
-        {
+        for (int i = 0; i < IMAGE_AREA; i++) {
             int colorIndex = data.colors[i];
             //value is divided by 4 to get the map colour id
-            if(colorIndex >> 2 == 0)
-            {
+            if (colorIndex >> 2 == 0) {
                 //if blank, render checkerboard texture
-                mapImageData[i] = (i + i / 128 & 1) * 8 + 16 << 24;
+                this.mapImageData[i] = (i + i / 128 & 1) * 8 + 16 << 24;
                 continue;
             }
             int col = MaterialColor.getColorFromIndex(colorIndex >> 2);
@@ -58,55 +55,52 @@ public class MapItemRenderer
 
             int shade = 220;
             // if higher shade
-            if(i1 == 2)
-            {
+            if (i1 == 2) {
                 shade = 255;
             }
             // if lower shade
-            if(i1 == 0)
-            {
+            if (i1 == 0) {
                 shade = 180;
             }
 
 
-            int red =   (Color.redFromInt(col)   * shade) / 255;
+            int red = (Color.redFromInt(col) * shade) / 255;
             int green = (Color.greenFromInt(col) * shade) / 255;
-            int blue =  (Color.blueFromInt(col)  * shade) / 255;
-            mapImageData[i] = Color.intToIntARGB(255, red, green, blue);
+            int blue = (Color.blueFromInt(col) * shade) / 255;
+            this.mapImageData[i] = Color.intToIntARGB(255, red, green, blue);
         }
 
 
-        textureManager.updateTextureData(mapImageData, 128, 128, mapTexture.id());
+        textureManager.updateTextureData(this.mapImageData, 128, 128, this.mapTexture.id());
         int j = 0;
         int k = 0;
         float f = 0.0F;
         //renders the map
-        mapTexture.bind();
-        GL11.glEnable(GL11.GL_BLEND);
+        this.mapTexture.bind();
+        GLRenderer.enableState(State.BLEND);
         GL11.glDisable(GL11.GL_ALPHA_TEST);
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV((float)(j) + f, (float)(k + 128) - f, -0.01D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 128) - f, -0.01D, 1.0D, 1.0D);
-        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k) + f, -0.01D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV((float)(j) + f, (float)(k) + f, -0.01D, 0.0D, 0.0D);
+        tessellator.addVertexWithUV((float) (j) + f, (float) (k + 128) - f, -0.01D, 0.0D, 1.0D);
+        tessellator.addVertexWithUV((float) (j + 128) - f, (float) (k + 128) - f, -0.01D, 1.0D, 1.0D);
+        tessellator.addVertexWithUV((float) (j + 128) - f, (float) (k) + f, -0.01D, 1.0D, 0.0D);
+        tessellator.addVertexWithUV((float) (j) + f, (float) (k) + f, -0.01D, 0.0D, 0.0D);
         tessellator.draw();
         GL11.glEnable(GL11.GL_ALPHA_TEST);
-        GL11.glDisable(GL11.GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
 
-        for(Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix())
-        {
+        for (Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
             MapWaypoint mapWaypoint = iterator.next();
-            GL11.glPushMatrix();
-            GL11.glTranslatef((float)j + (float)mapWaypoint.mapCoordX / 2.0F + 64, (float)k + (float)mapWaypoint.mapCoordZ / 2.0F + 64, -0.02F);
-            GL11.glRotatef((float)(8 * 360) / 16F , 0.0F, 0.0F, 1.0F);
-            GL11.glScalef(4F, 4F, 3F);
-            GL11.glTranslatef(-0.125F, 0.125F, 0.0F);
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate((float) j + (float) mapWaypoint.mapCoordX / 2.0F + 64, (float) k + (float) mapWaypoint.mapCoordZ / 2.0F + 64, -0.02F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians((8 * 360) / 16F));
+            GLRenderer.modelM4f().scale(4F, 4F, 3F);
+            GLRenderer.modelM4f().translate(-0.125F, 0.125F, 0.0F);
             double zIndex = 0.0d;
-            float f1 = (float)(5 % 4) / 4F;
-            float f2 = (float)(5 / 4) / 4F;
-            float f3 = (float)(5 % 4 + 1) / 4F;
-            float f4 = (float)(5 / 4 + 1) / 4F;
+            float f1 = (float) (5 % 4) / 4F;
+            float f2 = (float) (5 / 4) / 4F;
+            float f3 = (float) (5 % 4 + 1) / 4F;
+            float f4 = (float) (5 / 4 + 1) / 4F;
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(-1D, 1.0D, zIndex, f1, f2);
             tessellator.addVertexWithUV(1.0D, 1.0D, zIndex, f3, f2);
@@ -116,19 +110,18 @@ public class MapItemRenderer
         }
         //renders map icons
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
-        for(Iterator<ItemMapSavedData.MapDecoration> iterator = data.decorations.iterator(); iterator.hasNext(); GL11.glPopMatrix())
-        {
+        for (Iterator<ItemMapSavedData.MapDecoration> iterator = data.decorations.iterator(); iterator.hasNext(); GLRenderer.popFrame()) {
             ItemMapSavedData.MapDecoration decoration = iterator.next();
-            GL11.glPushMatrix();
-            GL11.glTranslatef((float)j + (float)decoration.x / 2.0F + 64, (float)k + (float)decoration.y / 2.0F + 64, -0.02F);
-            GL11.glRotatef((decoration.rot * 360F) / ItemMapSavedData.MapDecoration.ROTATION_STEPS, 0.0F, 0.0F, 1.0F);
-            GL11.glScalef(4F, 4F, 3F);
-            GL11.glTranslatef(-0.125F, 0.125F, 0.0F);
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate((float) j + (float) decoration.x / 2.0F + 64, (float) k + (float) decoration.y / 2.0F + 64, -0.02F);
+            GLRenderer.modelM4f().rotateZ((decoration.rot * Math.PI_TIMES_2_f) / ItemMapSavedData.MapDecoration.ROTATION_STEPS);
+            GLRenderer.modelM4f().scale(4F, 4F, 3F);
+            GLRenderer.modelM4f().translate(-0.125F, 0.125F, 0.0F);
             double zIndex = -1.0d;
-            float f1 = (float)(decoration.type % 4) / 4F;
-            float f2 = (float)(decoration.type / 4) / 4F;
-            float f3 = (float)(decoration.type % 4 + 1) / 4F;
-            float f4 = (float)(decoration.type / 4 + 1) / 4F;
+            float f1 = (float) (decoration.type % 4) / 4F;
+            float f2 = (float) (decoration.type / 4) / 4F;
+            float f3 = (float) (decoration.type % 4 + 1) / 4F;
+            float f4 = (float) (decoration.type / 4 + 1) / 4F;
 
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(-1D, 1.0D, zIndex, f1, f2);
@@ -138,47 +131,47 @@ public class MapItemRenderer
             tessellator.draw();
 
 
-            GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         }
-        GL11.glPushMatrix();
+        GLRenderer.pushFrame();
 
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/flagicon.png"));
         // begin drawing flag colors
-        for(Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
+        for (Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
             MapWaypoint mapWaypoint = iterator.next();
-            GL11.glPushMatrix();
+            GLRenderer.pushFrame();
             for (int y = 0; y < 3; y++) {
                 for (int x = 0; x < 3; x++) {
-					Color color = Colors.allFlagColors[15 - mapWaypoint.colors[x * 3 + y]];
-                	float red = color.getRed() / 255.0f;
-                	float green = color.getGreen() / 255.0f;
-                	float blue = color.getBlue() / 255.0f;
-                	GL11.glColor4f(red * brightness, green * brightness, blue * brightness, 1.0f);
-                    GL11.glPushMatrix();
-                    GL11.glTranslatef((float) (j + x % 3) + (float) (mapWaypoint.mapCoordX) / 2.0F + 64F, (float) (k + y % 3) + (float) (mapWaypoint.mapCoordZ) / 2.0F + 64F, -0.0F);
-                    GL11.glRotatef((float) (8 * 360) / 16F, 0.0F, 0.0F, 1.0F);
-                    GL11.glScalef(0.5F, 0.5F, 0.5F);
-                    GL11.glTranslatef(0.0F, 4F, 0.0F);
+                    Color color = Colors.allFlagColors[15 - mapWaypoint.colors[x * 3 + y]];
+                    float red = color.getRed() / 255.0f;
+                    float green = color.getGreen() / 255.0f;
+                    float blue = color.getBlue() / 255.0f;
+                    GLRenderer.setColor4f(red, green, blue, 1.0f);
+                    GLRenderer.pushFrame();
+                    GLRenderer.modelM4f().translate((float) (j + x % 3) + (float) (mapWaypoint.mapCoordX) / 2.0F + 64F, (float) (k + y % 3) + (float) (mapWaypoint.mapCoordZ) / 2.0F + 64F, -0.0F);
+                    GLRenderer.modelM4f().rotateZ(Math.toRadians((8 * 360) / 16F));
+                    GLRenderer.modelM4f().scale(0.5F, 0.5F, 0.5F);
+                    GLRenderer.modelM4f().translate(0.0F, 4F, 0.0F);
                     double zIndex = -0.1d;
-                    float flagXMin = (float) ((x+y) % 4) / 4F;
-                    float flagYMin = (float) ((x+y) / 4) / 4F;
-                    float flagXMax = (float) ((x+y) % 4 + 1) / 4F;
-                    float flagYMax = (float) ((x+y) / 4 + 1) / 4F;
+                    float flagXMin = (float) ((x + y) % 4) / 4F;
+                    float flagYMin = (float) ((x + y) / 4) / 4F;
+                    float flagXMax = (float) ((x + y) % 4 + 1) / 4F;
+                    float flagYMax = (float) ((x + y) / 4 + 1) / 4F;
                     tessellator.startDrawingQuads();
                     tessellator.addVertexWithUV(-1D, 1.0D, zIndex, flagXMin, flagYMin);
                     tessellator.addVertexWithUV(1.0D, 1.0D, zIndex, flagXMax, flagYMin);
                     tessellator.addVertexWithUV(1.0D, -1D, zIndex, flagXMax, flagYMax);
                     tessellator.addVertexWithUV(-1D, -1D, zIndex, flagXMin, flagYMax);
                     tessellator.draw();
-                    GL11.glPopMatrix();
+                    GLRenderer.popFrame();
                 }
             }
         }
 
-        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
-        GL11.glTranslatef(0.0F, 0.0F, -0.04F);
-        GL11.glScalef(1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        GLRenderer.modelM4f().translate(0.0F, 0.0F, -0.04F);
+        GLRenderer.modelM4f().scale(1.0F, 1.0F, 1.0F);
         //field_28160_d.drawString("X: " + (int)entityplayer.posX + " Z: " + (int)entityplayer.posZ, j, k, 0xff000000);
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index 5f44c9b2f..fedbe58df 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -1,100 +1,82 @@
 package net.minecraft.client.render;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.HashSet;
 import java.util.Set;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
+import net.minecraft.core.enums.EnumOS;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
 import org.lwjgl.opengl.ContextCapabilities;
+import org.lwjgl.opengl.GL41;
+import org.lwjgl.opengl.GLCapabilities;
 import org.lwjgl.opengl.GLContext;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.shader.Shaders;
 import org.slf4j.Logger;
 
 public class OpenGLHelper {
-	private static final Logger LOGGER = LogUtils.getLogger();
-	private static final Set<String> errors = new HashSet<>();
-	
-	public static boolean enableOcclusionCheck = false;
-	public static boolean enableSphericalFog = false;
-	public static boolean gl20 = false;
-	public static boolean gl31 = false;
-	public static boolean gl32 = false;
-	public static boolean gl43 = false;
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final Set<String> errors = new HashSet<>();
+
+    public static int[] versionPairs = new int[] {4, 6, 4, 3, 4, 1};
 
-    public static void testCapabilities(Minecraft minecraft) {
-		LOGGER.info("");
-		LOGGER.info("=== GPU VENDOR INFO ===");
-        LOGGER.info(glGetString(GL_VERSION));
-        LOGGER.info(glGetString(GL_VENDOR));
-        LOGGER.info(glGetString(GL_RENDERER));
+    public static boolean gl46 = false;
+    public static boolean gl43 = false;
 
-		LOGGER.info("");
+    public static void testCapabilities(@NotNull GLCapabilities capabilities) {
+        LOGGER.info("");
+        LOGGER.info("=== GPU VENDOR INFO ===");
+        LOGGER.info("OpenGL {}.{}", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION));
+        LOGGER.info(GL41.glGetString(GL41.GL_VERSION));
+        LOGGER.info(GL41.glGetString(GL41.GL_VENDOR));
+        LOGGER.info(GL41.glGetString(GL41.GL_RENDERER));
+
+        LOGGER.info("");
 
-        ContextCapabilities capabilities = GLContext.getCapabilities();
         LOGGER.info("GL_ARB_framebuffer_object: {}", capabilities.GL_ARB_framebuffer_object);
         LOGGER.info("GL_ARB_occlusion_query: {}", capabilities.GL_ARB_occlusion_query);
         LOGGER.info("GL_NV_fog_distance: {}", capabilities.GL_NV_fog_distance);
-        
-        enableOcclusionCheck = capabilities.GL_ARB_occlusion_query;
-        enableSphericalFog = capabilities.GL_NV_fog_distance;
-        gl20 = capabilities.OpenGL20;
-        gl31 = capabilities.OpenGL31;
-        gl32 = capabilities.OpenGL32;
-		gl43 = capabilities.OpenGL43;
 
-		LOGGER.info("");
-        
-		if(minecraft.gameSettings.disableShaders.value) {
-			Shaders.enableShaders = false;
-			LOGGER.warn("Shaders disabled in options file!");
-			return;
-		}
-		
-		Shaders.enableShaders = capabilities.GL_ARB_framebuffer_object && capabilities.OpenGL20;
+        gl43 = capabilities.OpenGL43;;
+        gl46 = capabilities.OpenGL46;
 
-        LOGGER.info("Shaders enabled: {}", Shaders.enableShaders);
-		LOGGER.info("");
+        if (!capabilities.OpenGL41) {
+            if (Minecraft.getOs() == EnumOS.macos) {
+                LOGGER.warn("BTA Requires OpenGL4.1 but only {} was found! If you're on MacOS this is probably just Apple misreporting the GLVersion number and not actually due to a lack of support.", GL41.glGetString(GL41.GL_VERSION));
+            } else {
+                LOGGER.error("BTA Requires OpenGL4.1 but only {} was found!", GL41.glGetString(GL41.GL_VERSION));
+            }
+        }
     }
-	
-	public static void checkError(String info) {
-		int errorCode = glGetError();
-		
-		if(errorCode != GL_NO_ERROR) {
-			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
-				String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-				throw new RuntimeException("OpenGL Error " + error);
-			}
-			
-			if(!errors.contains(info)) {
-				errors.add(info);
-				String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-	            LOGGER.error("########## GL ERROR ##########");
+
+    public static void checkError(String info) {
+        int errorCode = GL41.glGetError();
+
+        if (errorCode != GL41.GL_NO_ERROR) {
+            if (Global.BUILD_CHANNEL.isUnstableBuild()) {
+                String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+                throw new RuntimeException("OpenGL Error " + error);
+            }
+
+            if (!errors.contains(info)) {
+                errors.add(info);
+                String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+                LOGGER.error("########## GL ERROR ##########");
                 LOGGER.error("OpenGL Error {}", error);
-			}
-		}
-	}
-	
-	public static String getErrorDescription(int error) {
-		if(error == GL_INVALID_ENUM) return "Invalid Enum";
-		if(error == GL_INVALID_VALUE) return "Invalid Value";
-		if(error == GL_INVALID_OPERATION) return "Invalid Operation";
-		if(error == ARBFramebufferObject.GL_INVALID_FRAMEBUFFER_OPERATION) return "Invalid Framebuffer Operation";
-		if(error == GL_OUT_OF_MEMORY) return "Out of Memory";
-		if(error == GL_STACK_UNDERFLOW) return "Stack Underflow";
-		if(error == GL_STACK_OVERFLOW) return "Stack Overflow";
-		return "Unknown Error";
-	}
+            }
+        }
+    }
 
-	public static void glColor1i(int argb) {
-		float a = (float)(argb >> 24 & 0xff) / 255F;
-		float r = (float)(argb >> 16 & 0xff) / 255F;
-		float g = (float)(argb >> 8 & 0xff) / 255F;
-		float b = (float)(argb & 0xff) / 255F;
-		glColor4f(r, g, b, a);
-	}
+    public static String getErrorDescription(int error) {
+        if (error == GL41.GL_INVALID_ENUM) return "Invalid Enum";
+        if (error == GL41.GL_INVALID_VALUE) return "Invalid Value";
+        if (error == GL41.GL_INVALID_OPERATION) return "Invalid Operation";
+        if (error == ARBFramebufferObject.GL_INVALID_FRAMEBUFFER_OPERATION) return "Invalid Framebuffer Operation";
+        if (error == GL41.GL_OUT_OF_MEMORY) return "Out of Memory";
+        if (error == GL41.GL_STACK_UNDERFLOW) return "Stack Underflow";
+        if (error == GL41.GL_STACK_OVERFLOW) return "Stack Overflow";
+        return "Unknown Error";
+    }
 }
